pmarlen-web/src/main/java/com/pmarlen/proto/model/Car.java
package com.pmarlen.proto.model;

public class Car {
	private String id;
	private String brand;
	private Integer year;	
	private String color;
	private Integer price;	
	private boolean soldState;

	public Car() {
	}

	public Car(String id, String brand, Integer year, String color, Integer price, boolean soldState) {
		this.id = id;
		this.brand = brand;
		this.year = year;
		this.color = color;
		this.price = price;
		this.soldState = soldState;
	}
	
	
	//new Car(getRandomId(), getRandomBrand(), getRandomYear(), getRandomColor(), getRandomPrice(), getRandomSoldState())
	/**
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * @return the year
	 */
	public Integer getYear() {
		return year;
	}

	/**
	 * @param year the year to set
	 */
	public void setYear(Integer year) {
		this.year = year;
	}

	/**
	 * @return the brand
	 */
	public String getBrand() {
		return brand;
	}

	/**
	 * @param brand the brand to set
	 */
	public void setBrand(String brand) {
		this.brand = brand;
	}

	/**
	 * @return the color
	 */
	public String getColor() {
		return color;
	}

	/**
	 * @param color the color to set
	 */
	public void setColor(String color) {
		this.color = color;
	}

	/**
	 * @return the price
	 */
	public Integer getPrice() {
		return price;
	}

	/**
	 * @param price the price to set
	 */
	public void setPrice(Integer price) {
		this.price = price;
	}

	/**
	 * @return the soldState
	 */
	public boolean isSoldState() {
		return soldState;
	}

	/**
	 * @param soldState the soldState to set
	 */
	public void setSoldState(boolean soldState) {
		this.soldState = soldState;
	}
}

pmarlen-web/src/main/java/com/pmarlen/jsf/LineaMB.java
package com.pmarlen.jsf;

import com.pmarlen.model.beans.Linea;
import com.pmarlen.model.controller.LineaJPAController;
import java.util.List;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@ManagedBean(name="lineaMB")
@SessionScoped
@Component
public class LineaMB {
    @Autowired
    LineaJPAController lineaJPAController;

	public LineaMB() {
		System.out.println("->LineaMB created.");
	}
	
	public void setLineaJPAController(LineaJPAController lineaJPAController) {
		this.lineaJPAController = lineaJPAController;
	}
	
	public List<Linea> getLineaList() {
		return this.lineaJPAController.findAllEntities();
	}
	
}

pmarlen-web/src/main/java/com/pmarlen/web/security/managedbean/SessionUserMB.java
package com.pmarlen.web.security.managedbean;

import java.util.*;
import java.text.*;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import com.pmarlen.model.beans.Usuario;
import com.pmarlen.model.beans.Perfil;
import com.pmarlen.model.controller.UsuarioJPAController;
import com.pmarlen.model.Constants;
import com.pmarlen.web.servlet.ContextAndSessionListener;
import com.pmarlen.web.servlet.SessionInfo;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@ManagedBean(name="sessionUserMB")
@SessionScoped
@Component
public class SessionUserMB {

	private final Logger logger = LoggerFactory.getLogger(SessionUserMB.class);
	private static SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss:SSS");
	@Autowired
	private UsuarioJPAController usuarioJPAController;
	
	private Usuario usuarioAuthenticated;

	public void setUsuarioJPAController(UsuarioJPAController usuarioJPAController) {
		this.usuarioJPAController = usuarioJPAController;
	}

	public Usuario getUsuarioAuthenticated() {
		if (usuarioAuthenticated == null) {
			FacesContext fCtx = FacesContext.getCurrentInstance();
			ExternalContext externalContext = fCtx.getExternalContext();
			HttpSession session = (HttpSession) externalContext.getSession(false);
			String sessionId = session.getId();
			
			String remoteUser      = externalContext.getRemoteUser();
			String userPrincipal   = externalContext.getUserPrincipal().getName();
			
			logger.info("==>> getUsuarioAuthenticated : Session[" + sessionId + "] first enter: remoteUser=" + remoteUser+", userPrincipal=" + userPrincipal);
				
			if (remoteUser != null) {
				
				Date creationTime = new Date(session.getCreationTime());

				logger.debug("==>> UsuarioAuthenticated : Session[" + sessionId + "] created     :" + sdf.format(creationTime));
				logger.debug("==>> UsuarioAuthenticated : Session[" + sessionId + "] new         ?" + session.isNew());
				usuarioAuthenticated = this.usuarioJPAController.findById(remoteUser);
				if (usuarioAuthenticated != null && !session.isNew()) {
					logger.debug("\t==>> usuarioAuthenticated : Session[" + sessionId + "] True enter :" + usuarioAuthenticated);
					SessionInfo si = ContextAndSessionListener.sessionInfoHT.get(sessionId);
					if (si != null) {
						si.setUserName(remoteUser);
					} else {
						si = new SessionInfo(session, usuarioAuthenticated.getNombreCompleto());
						ContextAndSessionListener.sessionInfoHT.put(sessionId, si);
					}
				}
			}
		}
		return usuarioAuthenticated;
	}

	public String getSessionTimeOutMinus3SecsToDisplay() {
		HttpServletRequest r = null;

		r = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		r.getSession().getMaxInactiveInterval();

		return String.valueOf(r.getSession().getMaxInactiveInterval() - 3);
	}

	public void updateLastVisitedPage(String page) {
		FacesContext fCtx = FacesContext.getCurrentInstance();
		ExternalContext externalContext = fCtx.getExternalContext();
		HttpSession session = (HttpSession) externalContext.getSession(false);
		HttpServletRequest request = (HttpServletRequest) (externalContext.getRequest());
		String sessionId = session.getId();
		String userAgent = request.getHeader("User-Agent");
		String remoteAdrrInfo = request.getRemoteAddr() + "(" + request.getRemoteHost() + ")";
		logger.debug("==>> updateLastVisitedPage : page"+page+" from : "+ remoteAdrrInfo +" using:"+userAgent);
		SessionInfo si = ContextAndSessionListener.sessionInfoHT.get(sessionId);
		if(si != null) {
			si.setLastVisitedPage(page);
			si.setRemoteAddr(remoteAdrrInfo);
			if(userAgent != null){
				si.setUserAgent(userAgent);
			}
		}
	}

	public boolean isRootUser() {
		if (usuarioAuthenticated != null) {
			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_ROOT);
			return perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}

	public boolean isAdminUser() {
		if (usuarioAuthenticated != null) {
			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_ADMIN);
			return isRootUser() || perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}

	public boolean isSalesUser() {
		if (usuarioAuthenticated != null) {

			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_SALES);
			return isRootUser() || perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}

	public boolean isStockUser() {
		if (usuarioAuthenticated != null) {
			Perfil perfilFinalUser = new Perfil();
			Collection<Perfil> perfilCollection = usuarioAuthenticated.getPerfilCollection();
			perfilFinalUser.setId(Constants.PERFIL_STOCK);
			return isRootUser() || perfilCollection.contains(perfilFinalUser);
		} else {
			return false;
		}
	}
}

pmarlen-web/src/main/webapp/WEB-INF/templates/mainWithMenu.xhtml
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:p="http://primefaces.org/ui">

    <f:view contentType="text/html">
        <h:head>
            <f:facet name="first">
                <meta http-equiv="X-UA-Compatible" content="EmulateIE8" />
                <meta content='text/html; charset=UTF-8' http-equiv="Content-Type"/>
                <title><ui:insert name="title"/></title>
            </f:facet>
			<link type="text/css" rel="stylesheet" href="#{request.contextPath}/css/default.css" />            
        </h:head>


        <h:body>

			<h:form>

				<h:panelGrid columns="2" style="width: 100%">
					<h:panelGrid columns="2" >
						
						<h:outputLink id="link1" value="#{request.contextPath}/pages/home.jsf">
							<p:graphicImage value="/images/turboload/Logo_T2.gif" alt="(LOGO)" title="PERFUMERIA-MARLEN > INICIO"/>
						</h:outputLink>
						<h:panelGrid columns="1">
							<h:outputText value="PERFUMERIA MARLEN S.A. DE C.V."	style="font: normal 100% 'News Cycle', arial, sans-serif;"/>
							<h:outputText value="DISTRIBUCIONES"					style="font: normal 60%  'News Cycle', arial, sans-serif;"/>
						</h:panelGrid>
					</h:panelGrid>
					<p:menubar>
						<p:submenu label="OPERACION" icon="ui-icon-document">
							<p:submenu label="New" icon="ui-icon-contact">
								<p:menuitem value="Project" url="#" />
								<p:menuitem value="Other" url="#" />
							</p:submenu>
							<p:menuitem value="Open" url="#" />
							<p:menuitem value="Quit" url="#" />
						</p:submenu>

						<p:submenu label="ADMINISTRACION" icon="ui-icon-pencil">
							<p:menuitem value="Undo" url="#" icon="ui-icon-arrowreturnthick-1-w"></p:menuitem>
							<p:menuitem value="Redo" url="#" icon="ui-icon-arrowreturnthick-1-e"></p:menuitem>
						</p:submenu>

						<p:submenu label="CONTROL" icon="ui-icon-pencil">
							<p:menuitem value="Undo" url="#" icon="ui-icon-arrowreturnthick-1-w"></p:menuitem>
							<p:menuitem value="Redo" url="#" icon="ui-icon-arrowreturnthick-1-e"></p:menuitem>
						</p:submenu>

						<f:facet name="options">									
							<p:menuButton value="#{sessionUserMB.usuarioAuthenticated.nombreCompleto}">
								<p:menuitem value="SALIR" url="/logout" icon="ui-icon-extlink" />
								<p:menuitem value="AYUDA" url="#{request.contextPath}/pages/home.jsf" icon="ui-icon-help"/>

							</p:menuButton>
						</f:facet>
					</p:menubar>
				</h:panelGrid>
			</h:form>

			<h:form>
				<p:panel id="basic" styleClass="preferencesPanel">
					<f:facet name="header">
						<ui:insert name="body-title">BodyTitle</ui:insert>
					</f:facet>

					<h:panelGrid columns="1" style="margin: auto;background-color: transparent; width: 100%; height: inherit; ">

						<h:panelGroup style="display:block; text-align:center; background-color: transparent; ">

							<ui:insert name="body">Body</ui:insert>

						</h:panelGroup>

					</h:panelGrid>
				</p:panel>
				<br/>
				<br/>
			</h:form>
			
			<h:panelGroup class="footer-bar">

				<h:outputText value="FOOTER" />

			</h:panelGroup>

        </h:body>

    </f:view>
</html>

pmarlen-web/src/main/webapp/index.jsp
<%
    response.sendRedirect("pages/home.jsf");
%>

pmarlen-web/src/main/webapp/login.jsp
<%@ page pageEncoding="UTF-8" %>

<html>
    <head>
		<title>MAIN_SHORT_TITLE</title>
    </head>

    <body style="background-color: #DCEBF2;">	
		<br/>
		<br/>		
        <form action="j_security_check" method="post" id="loginForm">

			<table class="login_table_panel" border="0">
				<tr>
					<td colspan="3" valign="middle" align="center" style="background-color:gray;">
						MAIN_SYSTEM_ACCESS
					</td>
				</tr>
				<tr>
					<td width="20%" rowspan="6" valign="middle" align="center" >
						IMG-SECURE
					</td>
				</tr>
				<tr><td colspan="2">&nbsp;</td></tr>
				<tr><td colspan="2">&nbsp;</td></tr>
				<tr>
					<td width="40%" align="right">
						<span style="font-size : 10px;">LOGIN_USER :</span>
					</td>
					<td align="left">
						<input type="text" name="j_username" value="" size="8"/>
					</td>
				</tr>
				<tr>
					<td width="40%" align="right">
						<span style="font-size : 10px;">LOGIN_PASSWORD :</span>
					</td>
					<td align="left">
						<input type="password" name="j_password" value="" size="8"/>
					</td>
				</tr>

				<tr>
					<td colspan="2">
						<%
							if (request.getParameter("error") != null) {
						%>
							ERROR AUTHENTICATE
						<%
							} else {
						%>
						<%    
							}
						%>									
					</td>
				</tr>												

				<tr>
					<td colspan="3" width="100%" align="center">										
						<input type="submit" value="COMMON_OK" />
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</body>	
</html>

pmarlen-web/src/main/webapp/loginRealm.jsp
<%@ page language="java" import="com.pmarlen.web.common	.view.messages.Messages" %>
<%@ page language="java" import="java.util.Locale" %>
<%@ page pageEncoding="UTF-8" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<jsp:useBean id="versionInfo" class="com.pmarlen.web.common.view.messages.VersionInfo"  scope="session"/>

<c:set var="language" value="${not empty param.language ? param.language : not empty language ? language : pageContext.request.locale}" scope="session" />

<fmt:setLocale value="${language}" />
<fmt:setBundle basename="com.pmarlen.web.common.view.properties.UIMessages" />

<%
	//Messages messages = new Messages("com.pmarlen.web.common.view.properties.UIMessages");
	String acceptLanguage = request.getHeader("Accept-Language");
	System.err.println("Header[Accept-Language]:" + acceptLanguage);
	Locale reqLocale = request.getLocale();
	System.err.println("Request Locale : " + reqLocale);
	String userAgent = request.getHeader("User-Agent");
	System.err.println("Header[User-Agent]:" + userAgent);

	if (userAgent.toLowerCase().contains("android")) {
		request.getSession().setAttribute("viewingFromMobile", 1);
		System.err.println("\t-->>>viewingFromMobile=1");
	} else {
		System.err.println("\t-->>>viewingFromMobile=0, es normal");
	}
%>
<html>
    <head>
		<title><fmt:message key="MAIN_SHORT_TITLE" /> : <fmt:message key="MAIN_SYSTEM_ACCESS" /></title>

		<link 	href="<%= request.getContextPath()%>/images/Logo_icono_2.gif" 	rel="shortcut icon"  type="image/x-icon"/>
        <link	href="<%= request.getContextPath()%>/images/Logo_icono_2.gif"   rel="icon"           type="image/x-icon"/>

		<script >
			function init() {
				console.log("-->>init()");
				timedMsg();
				document.forms[0].j_username.focus();
			}
			function timedMsg() {
				console.log("-->>timedMsg()");
				var t = setTimeout("returnToHome();",<%=((request.getSession().getMaxInactiveInterval() * 1000 - 10))%>);
			}
			function returnToHome() {
				console.log("-->>returnToHome()");
				window.location = "<%=request.getContextPath()%>";
			}

		</script>

    </head>

    <body onload="init();" style="background-color: #DCEBF2;">	
        <form>
			<div style="text-align: right">				
			<!--	
			<input type="radio" name="language" value="en" ${language == 'en' ? 'checked' : ''} onclick="submit();"> <img src="<%= request.getContextPath()%>/images/flag-en.gif"/></input>
			<input type="radio" name="language" value="es" ${language == 'es' ? 'checked' : ''} onclick="submit();"> <img src="<%= request.getContextPath()%>/images/flag-es_MX.gif"/></input>
			-->
			</div>
        </form>
		<br/>
		<br/>		
        <form action="j_security_check" method="post" id="loginForm" onsubmit="return sendAjaxBeforeSubmit();">

			<table cellpadding="0" cellspacing="0" border="0" width="800" align="center">
				<tr>
					<td align="center"  valign="middle" width="200" >
						<img src="<%= request.getContextPath()%>/images/LogoOriginal_5_Q25.jpg"/>
					</td>
					<td align="center"  valign="middle">

						<h1> <fmt:message key="MAIN_LEGEND" /></h1>
						<h2> <fmt:message key="MAIN_SUBLEGEND" /></h2>
						<h3> <fmt:message key="MAIN_SYSTEM_NAME" /></h3>

					</td>
				</tr>
			</table>
			<br/>
			<br/>
			<table cellpadding="0" cellspacing="0" border="0" width="700" align="center">

				<tr>
					<td align="center"  valign="middle" width="300" >
						<img src="<%= request.getContextPath()%>/images/almacen_rack_Q25.jpg"/>
					</td>
					<td>
						<table class="login_table_panel" border="0">
							<tr>
								<td colspan="3" valign="middle" align="center" style="background-color:gray;">
									<fmt:message key="MAIN_SYSTEM_ACCESS" />
								</td>
							</tr>
							<tr>
								<td width="20%" rowspan="6" valign="middle" align="center" >
									<img src="<%= request.getContextPath()%>/images/secure_Q25.jpg" />
								</td>
							</tr>
							<tr><td colspan="2">&nbsp;</td></tr>
							<tr><td colspan="2">&nbsp;</td></tr>
							<tr>
								<td width="40%" align="right">
									<span style="font-size : 10px;"><fmt:message key="LOGIN_USER" /> :</span>
								</td>
								<td align="left">
									<input type="text" name="j_username" value="" size="8"/>
								</td>
							</tr>
							<tr>
								<td width="40%" align="right">
									<span style="font-size : 10px;"><fmt:message key="LOGIN_PASSWORD" /> :</span>
								</td>
								<td align="left">
									<input type="password" name="j_password" value="" size="8"/>
								</td>
							</tr>

							<tr>
								<td colspan="2">
									<%
										if (request.getParameter("error") != null) {
									%>									
									<div style="color: red;vertical-align: middle;">
										<br/>
										<img src="<%= request.getContextPath()%>/images/error16x16.gif" />&nbsp; 
										<span style="font-size : 10px;"><fmt:message key="LOGIN_ERROR_AUTHENTICATE" /></span>
										<br/>
										<br/>
									</div>
									<%
									} else {
									%>
									<br/>
									<br/>
									<%    }
									%>									
								</td>
							</tr>												

							<tr>
								<td colspan="3" width="100%" align="center">										
									<input type="submit" value="<fmt:message key="COMMON_OK" />"/>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>

		</td>
	</tr>
</table>
<br/>
<br/>
<table cellpadding="0" cellspacing="0" border="0" align="center">
	<tr>
		<td align="center" height="20">
			<a href="http://perfumeriamarlen.com.mx" style="color:#000; display:block" class="footer-text">[<fmt:message key="ENTERPRISE_INFO" />]</a>
		</td>
	</tr>
	<!--
	<tr>
		<td align="center">
			<div style="color:#A0A0A0; display:block" class="footer-text">
				<a href="http://xpressosystems.com">XPRESSO SYSTEMS</a>
			</div>
		</td>
	</tr>
	-->
	<tr>
		<td align="center">
			<div style="color:#A0A0A0; display:block" class="footer-text">
				<fmt:message key="APP_BUILD_LABEL" /> : <jsp:getProperty name="versionInfo" property="maven_build_timestamp" /> |
				<fmt:message key="APP_VERSION_LABEL" /> : <jsp:getProperty name="versionInfo" property="version" />
			</div>
		</td>
	</tr>
</table>

</form>

</body>	
</html>

pmarlen-web/src/main/webapp/pages/home.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="/WEB-INF/templates/mainWithMenu.xhtml">
    
    <ui:define name="title">
        THE HOME
    </ui:define>

    <ui:define name="body-title">
        THE HOME TITLE
    </ui:define>
    
    <ui:define name="body">
        THE HOME BODY #{request.contextPath}
		<h:panelGrid columns="1" >
			<h:panelGrid columns="1">
				
			</h:panelGrid>
			
			<p:dataTable var="car" value="#{dtBasicView.cars}">
				<p:column headerText="Id">
					<h:outputText value="#{car.id}" />
				</p:column>

				<p:column headerText="Year">
					<h:outputText value="#{car.year}" />
				</p:column>

				<p:column headerText="Brand">
					<h:outputText value="#{car.brand}" />
				</p:column>

				<p:column headerText="Color">
					<h:outputText value="#{car.color}" />
				</p:column>
			</p:dataTable>
		</h:panelGrid>
    </ui:define>

</ui:composition>

pmarlen-web/src/main/webapp/pages/linea.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:ui="http://java.sun.com/jsf/facelets"
				xmlns:f="http://java.sun.com/jsf/core"
                xmlns:p="http://primefaces.org/ui"
                template="/WEB-INF/templates/mainWithMenu.xhtml">
    
    <ui:define name="title">
        LINEA
    </ui:define>

    <ui:define name="body-title">
        LINEA
    </ui:define>
    
    <ui:define name="body">
        
		<h:panelGrid columns="1" >
			
			<p:dataTable var="linea" value="#{lineaMB.lineaList}"
						 paginator="true"
						 rows="10"
						 id="lineas"
                         paginatorTemplate="{CurrentPageReport}  {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
                         rowsPerPageTemplate="5,10,15">
				<f:facet name="header">
					OPCIONES
					<p:commandButton id="toggler" type="button" value="Columnas" style="float:right" icon="ui-icon-calculator" />
					<p:columnToggler datasource="lineas" trigger="toggler" />
				</f:facet>
				
				<p:column headerText="Id" sortBy="#{linea.id}">
					<h:outputText value="#{linea.id}" />
				</p:column>

				<p:column headerText="NOMBRE" sortBy="#{linea.nombre}">
					<h:outputText value="#{linea.nombre}" />
				</p:column>

			</p:dataTable>

		</h:panelGrid>
    </ui:define>

</ui:composition>